#ifndef ____UWUW_WIDGET_COLLECTION_H____
#define ____UWUW_WIDGET_COLLECTION_H____

#include "Orbitersdk.h"
#include <vector>

using namespace std;

class uwuwWIDGET;

class uwuwWIDGETCONTAINER : public VESSEL2 {
private:
	vector<uwuwWIDGET*> __widgets;
	double fDeltaT;
	double fLastSimT;
	bool fGroundContact;
	bool fCollision;
	double fColldV;
	//Flag to indicate that the object gets deleted
	bool fDead;
	void Finalize();
protected:
	virtual void CheckGroundContact();
	virtual void CheckCollision();
public:
	uwuwWIDGETCONTAINER(OBJHANDLE hVessel, int iFlightModel);
	void RegisterWidget(uwuwWIDGET* pWidget);
	/**
     * Remove the vessel from play.
	 */
	virtual void Terminate();
	/**
	 * Stop all ground relative velocities;
	 */
	void FullStop();
	virtual void clbkSetClassCaps(FILEHANDLE cfg);
	virtual void clbkPostStep(double fSimT, double fsimDT, double fMJD);
	virtual void clbkSetStateEx(const void* vs);
public:	
	/**
	 * Use this for the vessel
	 */
	virtual void onSetClassCaps(FILEHANDLE cfg);
	virtual void onTimestep(double fSimT, double fDeltaT);
	virtual void onCollision(double fdV);
	bool HasGroundContact();
	void LogEvent(const char* pszMessage,...);
};

class uwuwWIDGET {
private:
	uwuwWIDGETCONTAINER* ___Parent;
protected:
	uwuwWIDGETCONTAINER* Parent() const;
public:
	uwuwWIDGET(uwuwWIDGETCONTAINER* pParent);
	virtual void Create();
	virtual void OnSaveState(FILEHANDLE scn);
	virtual void OnLoadState(FILEHANDLE scn);
	virtual void OnTimestep(double fSimT, double fDeltaT);
	virtual void OnGroundContact();
	virtual void onCollision(double fdV);
};

class uwuwWARHEAD : public uwuwWIDGET {
	PARTICLESTREAMSPEC smoke1;
	PARTICLESTREAMSPEC flames1;
	PROPELLANT_HANDLE phWarhead;
	THRUSTER_HANDLE thExplosion[32];
protected:
	VECTOR3 wref;
	double fLScale;
	double fWScale;
	double fWarheadMass;
	bool fArmed;
	bool fIgnited;
	void CreateParticleData();
public:
	uwuwWARHEAD(uwuwWIDGETCONTAINER* pParent, VECTOR3 &ref, double fMass, double lScale, double wScale);
	virtual void Arm();
	virtual void Create();
	virtual void Ignite();
	virtual void OnSaveState(FILEHANDLE scn);
	virtual void OnLoadState(FILEHANDLE scn);
	virtual void OnTimestep(double fSimT, double fDeltaT);
	virtual void OnGroundContact();
	virtual void OnCollision(double fdV);
	
};

#endif